package com.lwby.marketing.controller;

import cn.hutool.crypto.SecureUtil;
import org.apache.commons.lang3.StringUtils;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;

public class ServiceHelper {
    public String emptyIsNull(String params){
        return StringUtils.defaultIfEmpty(params,null);
    }

    public String encode(String params){
        try {
            return URLEncoder.encode(params,"utf-8");
        } catch (UnsupportedEncodingException e) {
            return null;
        }
    }

    public Integer parseInt(String params){
        try {
            return Integer.valueOf(params);
        }catch (Exception e){
            return null;
        }
    }

    public String assembleKey(String deviceId, ClickbackService.DeviceType type) {
        switch (type) {
            case IMEI:
            case OAID:
            case IDFA:
                return deviceId;
            case IP_UA:
            case IP_MODEL:
            case IP:
                return SecureUtil.md5(deviceId);
        }
        return null;
    }

    public String assembleKey(String deviceId, ClickbackService.DeviceVideoType type) {
        switch (type) {
            case OAID:
            case IDFA:
                return deviceId;
            case IP_UA:
            case IP_MODEL:
                return SecureUtil.md5(deviceId);
        }
        return null;
    }

    public String getModelByUa(String ua) {
        String uasplit = ua.split("Build")[0];
        String model = null;
        try {
            if (ua.startsWith("com.")) {
                String[] split = uasplit.split(";");
                model = split[4].trim();
            } else {
                if (uasplit.split(";").length >= 3 && StringUtils.isNotEmpty(uasplit.split(";")[2].trim())) {
                    model = uasplit.substring(uasplit.lastIndexOf(";") + 2, uasplit.length() - 1);
                    model = URLEncoder.encode(model, "utf-8");
                }
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        return model;
    }
}
